#include "buff.h"
#include <avr/pgmspace.h>


char buff[BUFFER_LEN] = "";


inline uint8_t buff_chr(char* buff, char c, uint8_t pos, uint8_t bufflen) {
	if(pos >= bufflen) return pos;
	buff[pos] = c;
	return pos+1;
}

uint8_t buff_str(char *s, char* buff, uint8_t pos, uint8_t bufflen) {
	while(*s) {
		pos = buff_chr(buff, *s++, pos, bufflen);
	}
	buff[pos] = 0;
	return pos;
}


uint8_t buff_str_fla(const char *addr, char* buff, uint8_t pos, uint8_t bufflen) {
	char c;
	while((c = pgm_read_byte(addr++)) != 0) {
		pos = buff_chr(buff, c, pos, bufflen);
	}
	buff[pos] = 0;
	return pos;
}

uint8_t buff_int(uint32_t num, char* buff, uint8_t pos, uint8_t bufflen, uint8_t base) {
	char str[16];
	char *ptr = (char *)&str;
	do {
		*ptr = (num % base);
		*ptr += *ptr < 10 ? '0' : ('A' - 10);
		ptr++;
		num /= base;
	} while(num > 0);

	while(ptr > (char *)&str) {
		ptr--;
		pos = buff_chr(buff, *ptr, pos, bufflen);
	}
	buff[pos] = 0;
	return pos;
}

uint8_t buff_solar_temp(int16_t temp, char* buff, uint8_t pos, uint8_t bufflen) {
	//negativer Wert
	if(temp < 0) {
		temp *= -1;
		pos = buff_chr(buff, '-', pos, bufflen);
	}

	//Ganzzahl
	pos = buff_int(temp/10, buff, pos, bufflen, 10);

	//Komma
	pos = buff_chr(buff, '.', pos, bufflen);
	
	//Nachkommastelle
	temp %= 10;
	pos = buff_chr(buff, temp + '0', pos, bufflen);
	
	return pos;
}
